<?php
/**
 * Created by PhpStorm.
 * User: erikasantos
 * Date: 08/04/14
 * Time: 13:44
 */

namespace Geral\Facade\Estrutura;

class Parametros {

    public static function setContextVars(){
        tk_set_context_vars('NRPARAMFERIASM', 'gpe_tab_parametros_wzd', tk_get_field_value('NRPARAMFERIASM'));
        tk_set_context_vars('NRPARAMFOLHAM', 'gpe_tab_parametros_wzd', tk_get_field_value('NRPARAMFOLHAM'));
    }

    /**
     * Metodo 1003168 no metadados
     */
    public static function finalizaCadastro() {
        $nrorg            = \Geral\Util\Ambiente::getNrorgTrabalho();
        $dtmescompetencia = \Geral\Util\Ambiente::getDtCompetencia();

        self::cadastraEstrutura($nrorg, $dtmescompetencia);
    }

    public static function cadastraEstrutura($nrorg, $dtmescompetencia) {
        list($nmfantasia, $nmrazsocestrut, $dtinivigencia, $nrcalendario, $nrtipoestrutura, $cdcnpjestrut, $idtipoempr,
            $dtbasesindical, $cdsindical, $idparticipat, $idoptsimples, $cdnatujuri, $cdfpas, $cdcnae
            ) = self::getEstrutura();

        $cdtipoinscricao = ($cdcnpjestrut) ? 'CNPJ' : 'LIVRE';

        list($dsreferenciaende, $dscompleendereco, $nrcependereco, $nrimovelendereco, $dsendereco, $nmbairroendereco,
            $cdlogradouro, $cdmunicipio, $sgestado, $cdpais) = self::getEndereco();

        list($cdcomplecomuparc, $cdcomunicaparc, $cdprefixcomuparc, $cdformacomu) = self::getComunicacao();

        $nrparamferiasm = tk_get_field_value('NRPARAMFERIASM');
        $nrparamfolham  = tk_get_field_value('NRPARAMFOLHAM');

        Cadastros::estruturaCompleta(
            $nrorg, $nrtipoestrutura, $dtinivigencia, $dtmescompetencia, $cdsindical, $dtbasesindical, $cdnatujuri,
            $nmrazsocestrut, $nmfantasia, $cdcnpjestrut, $idtipoempr, $idoptsimples, $idparticipat, $nrcalendario,
            $cdcnae, $cdfpas, $cdtipoinscricao, $cdcnpjestrut, $cdpais, $sgestado, $cdmunicipio, $cdlogradouro,
            $nmbairroendereco, 'PRINCIPAL', $nrcependereco, $dscompleendereco, $nrimovelendereco, $dsendereco,
            $dsreferenciaende, $cdformacomu, $cdprefixcomuparc, $cdcomunicaparc, $cdcomplecomuparc, $nrparamferiasm,
            $nrparamfolham
        );

        tk_warning('Cadastro realizado com sucesso!');
    }

    public static function getEstrutura() {
        $nmfantasia      = tk_get_context_vars('NMFANTASIA', 'gpe_wnd_estrutura_wzd');
        $nmrazsocestrut  = tk_get_context_vars('NMRAZSOCESTRUT', 'gpe_wnd_estrutura_wzd');
        $dtinivigencia   = tk_get_context_vars('DTINIVIGENCIA', 'gpe_wnd_estrutura_wzd');
        $nrcalendario    = tk_get_context_vars('NRCALENDARIO', 'gpe_wnd_estrutura_wzd');
        $nrtipoestrutura = tk_get_context_vars('NRTIPOESTRUTURA', 'gpe_wnd_estrutura_wzd');
        $cdcnpjestrut    = tk_get_context_vars('NRTIPOESTRUTURA', 'gpe_wnd_estrutura_wzd');
        $idtipoempr      = tk_get_context_vars('IDTIPOEMPR', 'gpe_wnd_estrutura_wzd');
        $dtbasesindical  = tk_get_context_vars('DTBASESINDICAL', 'gpe_wnd_estrutura_wzd');
        $cdsindical      = tk_get_context_vars('CDSINDICAL', 'gpe_wnd_estrutura_wzd');
        $idparticipat    = tk_get_context_vars('IDPARTICIPAT', 'gpe_wnd_estrutura_wzd');
        $idoptsimples    = tk_get_context_vars('IDOPTSIMPLES', 'gpe_wnd_estrutura_wzd');
        $cdnatujuri      = tk_get_context_vars('CDNATUJURI', 'gpe_wnd_estrutura_wzd');
        $cdfpas          = tk_get_context_vars('CDFPAS', 'gpe_wnd_estrutura_wzd');
        $cdcnae          = tk_get_context_vars('CDCNAE', 'gpe_wnd_estrutura_wzd');
        return array(
            $nmfantasia, $nmrazsocestrut, $dtinivigencia, $nrcalendario, $nrtipoestrutura, $cdcnpjestrut, $idtipoempr,
            $dtbasesindical, $cdsindical, $idparticipat, $idoptsimples, $cdnatujuri, $cdfpas, $cdcnae
        );
    }

    public static function getEndereco() {
        $dsreferenciaende = tk_get_context_vars('DSREFERENCIAENDE', 'gpe_wnd_enderecoparc_wzd');
        $dscompleendereco = tk_get_context_vars('DSCOMPLEENDERECO', 'gpe_wnd_enderecoparc_wzd');
        $nrcependereco    = tk_get_context_vars('NRCEPENDERECO', 'gpe_wnd_enderecoparc_wzd');
        $nrimovelendereco = tk_get_context_vars('NRIMOVELENDERECO', 'gpe_wnd_enderecoparc_wzd');
        $dsendereco       = tk_get_context_vars('DSENDERECO', 'gpe_wnd_enderecoparc_wzd');
        $nmbairroendereco = tk_get_context_vars('NMBAIRROENDERECO', 'gpe_wnd_enderecoparc_wzd');
        $cdlogradouro     = tk_get_context_vars('CDLOGRADOURO', 'gpe_wnd_enderecoparc_wzd');
        $cdmunicipio      = tk_get_context_vars('CDMUNICIPIO', 'gpe_wnd_enderecoparc_wzd');
        $sgestado         = tk_get_context_vars('SGESTADO', 'gpe_wnd_enderecoparc_wzd');
        $cdpais           = tk_get_context_vars('CDPAIS', 'gpe_wnd_enderecoparc_wzd');
        return array(
            $dsreferenciaende, $dscompleendereco, $nrcependereco, $nrimovelendereco, $dsendereco, $nmbairroendereco,
            $cdlogradouro, $cdmunicipio, $sgestado, $cdpais
        );
    }

    public static function getComunicacao() {
        $cdcomplecomuparc = tk_get_context_vars('CDCOMPLECOMUPARC', 'gpe_wnd_comunicaparc_wzd');
        $cdcomunicaparc   = tk_get_context_vars('CDCOMUNICAPARC', 'gpe_wnd_comunicaparc_wzd');
        $cdprefixcomuparc = tk_get_context_vars('CDPREFIXCOMUPARC', 'gpe_wnd_comunicaparc_wzd');
        $cdformacomu      = tk_get_context_vars('CDFORMACOMU', 'gpe_wnd_comunicaparc_wzd');
        return array($cdcomplecomuparc, $cdcomunicaparc, $cdprefixcomuparc, $cdformacomu);
    }
}