/* Tecnisa - Tecnologia em Informtica

Nome: 9011_CTBSTP_EXCLUI_LANCAMENTO.SQL

Descrio:
 Procedimento para EXCLUSO do lanamento.

Criao:
__/__/__ - ______________________________

Manutenes:
25/11/99 Paulo Giovanni - Converso p/ SQL-SERVER
__/__/__ _________ - _____________________________________________
__/__/__ _________ - _____________________________________________
__/__/__ _________ - _____________________________________________
*/

/* PARMETROS : @P_CDEMPRESA - CDIGO DA EMPRESA                       */
/*              @P_NRLANCCONT - NMERO DO LANAMENTO                   */
/*              @P_EXEC_ALT - STATUS ('E'- EXCLUSO, 'A' -  ALTERAO) */

IF EXISTS(SELECT name FROM sysobjects
          WHERE name = 'EXCLUI_LANCAMENTO' AND type = 'P')
  DROP PROCEDURE EXCLUI_LANCAMENTO
  GO

CREATE PROCEDURE EXCLUI_LANCAMENTO
       			@P_CDEMPRESA varchar(2),
       			@P_NRLANCCONT varchar(12),
       			@P_EXEC_ALT varCHAR(1)
AS
/*VARIVEIS NORMAIS - INCIO*/
DECLARE @V_IDCONTGERE varchar(1);
DECLARE @V_IDCONTCOME varchar(1);
/*VARIVEIS NORMAIS - FIM*/


BEGIN

    SELECT @V_IDCONTGERE = MAX(IDCONTGERE), @V_IDCONTCOME = MAX(IDCONTCOME)
    FROM CONTOPECTBL
    WHERE(CDEMPRESA = @P_CDEMPRESA);


    UPDATE LANCCONT SET LANCCONT.VRLANCAMENT = LANCCONT.VRLANCAMENT * (-1),IDLANCSALDO = 'N'
    WHERE   (LANCCONT.CDEMPRESA = @P_CDEMPRESA)  AND
             (LANCCONT.NRLANCCONT = @P_NRLANCCONT);

    UPDATE LANCCCUSTO SET LANCCCUSTO.VRLANCCUST = LANCCCUSTO.VRLANCCUST * (-1)
    WHERE   (LANCCCUSTO.CDEMPRESA  = @P_CDEMPRESA)  AND
             (LANCCCUSTO.NRLANCCONT = @P_NRLANCCONT);

    EXEC ATUALIZA_SALDO_GERENCIAL @P_CDEMPRESA;
    EXEC ATUALIZA_SALDO_COMERCIAL @P_CDEMPRESA;
    EXEC ATUALIZA_SALDO_CONTABIL  @P_CDEMPRESA;

  /* INCIO DO IF*/
    IF (@P_EXEC_ALT = 'S' OR @P_EXEC_ALT = 'E')
    BEGIN
       DELETE LANCCONT
       WHERE (LANCCONT.CDEMPRESA = @P_CDEMPRESA)  AND
                    (LANCCONT.NRLANCCONT = @P_NRLANCCONT);
    END
    ELSE
    BEGIN
       UPDATE LANCCONT SET LANCCONT.VRLANCAMENT = LANCCONT.VRLANCAMENT * (-1),
              IDLANCSALDO = 'S'
       WHERE (LANCCONT.CDEMPRESA = @P_CDEMPRESA )  AND
             (LANCCONT.NRLANCCONT = @P_NRLANCCONT);
       UPDATE LANCCCUSTO SET LANCCCUSTO.VRLANCCUST = LANCCCUSTO.VRLANCCUST * (-1)
           WHERE (LANCCCUSTO.CDEMPRESA  = @P_CDEMPRESA)  AND
                 (LANCCCUSTO.NRLANCCONT = @P_NRLANCCONT);
    END ;
  /* FIM DO IF*/

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'EXCLUI_LANCAMENTO','5.05.020';
GO

