var Cmp07600_Alteracao_Aprovacao_Af_Controller = function(General, ScreenService, Utilities, templateManager, ZHPromise, Cmp03900_LancamentoAutorizacaoDeFornecimento_Service, ZhFilterPreferences, MessageService) {
    
    var self = this;
    
    let CDFILCENTCMP;
    
    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    /**
     * Define o filtro padrão de filial no popup de filtro,
     * setando o código e o nome da filial logada no sistema
     * na currentRow do popup do filtro.
    */
    this.setFilterInitValues = function(){   
	    /*filterRow.DATA_AF = {};
        filterRow.DATA_AF.start = moment().format('DD/MM/YYYY');
        filterRow.DATA_AF.end = moment().format('DD/MM/YYYY');
        filterRow.DATA_ENTREGA = {};
        filterRow.DATA_ENTREGA.start = moment().format('DD/MM/YYYY');
        filterRow.DATA_ENTREGA.end = moment().format('DD/MM/YYYY');*/
        
        return {
            "CDFILDEST": getLocalVar("CDFILIAL"),
            "CDFILIAL": [getLocalVar('CDFILIAL')],
            "NMFILIAL": [getLocalVar("NMFILIAL")],
            "ITENS_AF": "S",
            "NMTPAF": "A"
        };
    };
    
    /**
     * Método executado no evento "WidgetOnEnterOnce"
     * da widget principal.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.widgetOnEnter = function(widget){
        General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/getCentralCompras', "Row", {}).then(function(res){
            let fieldUnidade = widget.getField("CDFILIAL");
            
            CDFILCENTCMP = res.dataset.res.CDFILCENTCMP;
            
        	Utilities.startFilter(widget, this.setFilterInitValues());
            
            //fieldUnidade.filterProperties.readOnly = CDFILCENTCMP != getLocalVar('CDFILIAL');
            
            if (fieldUnidade.filterProperties.readOnly) {
                delete fieldUnidade.filterProperties.validations;
                delete fieldUnidade.validations;
            } else {
                fieldUnidade.validations = {
                    "required": true
                };
            }
            
            this.getParamGeralIdsisdos(widget);
        }.bind(this))
        .catch(function(error){
            ScreenService.showMessage(error.data.error);
        });
    };
    
    this.validaFiltro = function(widget){
        if(widget.PARAMGERAL.IDSISDOS == 3) {
            widget.getField('NMTPAF').dataSource.data = 
            [
                {
                    "NMTPAF": ScreenService.i18n("Automática"),
                    "CDTPAF": "A"
                }
            ];
        }
        else {
            widget.getField('NMTPAF').dataSource.data = 
            [
                {
                    "NMTPAF": ScreenService.i18n("Automática"),
                    "CDTPAF": "A"
                },
                {
                    "NMTPAF": ScreenService.i18n("Manual"),
                    "CDTPAF": "M"
                }

            ];
        }
    };
    
    /**
     * Seta alguns valores selecionados no filtro
     * na widget stripe.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF"), referente ao filtro
     * principal da tela.
    */
    this.setStripe= function(owner){
        
        var filterPopupCurrentRow = owner.appliedFilter.FILTER_ROW;
        var stripeWidget = templateManager.container.getWidget('WDGT_STRIPE');
        var gridWidget = templateManager.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
        var dtAfIni = filterPopupCurrentRow.DATA_AF ? filterPopupCurrentRow.DATA_AF.start : "";
        var dtAfFin = filterPopupCurrentRow.DATA_AF ? filterPopupCurrentRow.DATA_AF.end : "";
        var dtEntIni = filterPopupCurrentRow.DATA_ENTREGA ? filterPopupCurrentRow.DATA_ENTREGA.start : "";
        var dtEntFin = filterPopupCurrentRow.DATA_ENTREGA ? filterPopupCurrentRow.DATA_ENTREGA.end : "";
        
        var valuesToPutOnStripe = {
            NMFILIAL: filterPopupCurrentRow.NMFILIAL,
            DTAUTOFORN: this.returnRangeOnFilter(dtAfIni, dtAfFin, ScreenService.i18n(' até ')),
            DTPROGENTAF: this.returnRangeOnFilter(dtEntIni, dtEntFin, ScreenService.i18n(' até ')),
            RANGE_PRODUTOS: this.returnRangeOnFilter(filterPopupCurrentRow.NMPRODUTO_INICIAL, filterPopupCurrentRow.NMPRODUTO_FINAL, ScreenService.i18n(' até ')),
            NMTPAF: this.getAfTypeOnFilterPopupCurrentRow(owner),
            TPITEN: this.getSelectedItemTypeOnFilter(owner)
        };
        
        for (var field in valuesToPutOnStripe) {
            var currentField = stripeWidget.getField(field);
            this.concatValueToStripeFieldLabelAfterColon(currentField, valuesToPutOnStripe[field]);
        }
        
        owner._filterInfo = [
            { "label": ScreenService.i18n("Tipo da AF"),       "value" : filterPopupCurrentRow.CDTPAF },
            { "label": ScreenService.i18n("Agrupamento de Un"),"value": filterPopupCurrentRow.NMGRUPFILI },
            { "label": ScreenService.i18n("Data da AF"),       "value" : filterPopupCurrentRow.DATA_AF && filterPopupCurrentRow.DATA_AF.start && filterPopupCurrentRow.DATA_AF.end ? filterPopupCurrentRow.DATA_AF.start + ' / ' + filterPopupCurrentRow.DATA_AF.end : ''},
            { "label": ScreenService.i18n("Data de Entrega"),  "value" : filterPopupCurrentRow.DATA_ENTREGA && filterPopupCurrentRow.DATA_ENTREGA.start && filterPopupCurrentRow.DATA_ENTREGA.end ? filterPopupCurrentRow.DATA_ENTREGA.start + ' / ' + filterPopupCurrentRow.DATA_ENTREGA.end : ''},
            { "label": ScreenService.i18n("Produto Inicial"),  "value" : filterPopupCurrentRow.CDPRODUTO_INICIAL ? filterPopupCurrentRow.CDPRODUTO_INICIAL : "" },
            { "label": ScreenService.i18n("Produto Final"),    "value" : filterPopupCurrentRow.CDPRODUTO_FINAL   ? filterPopupCurrentRow.CDPRODUTO_FINAL   : "" },
            { "label": ScreenService.i18n("Itens AF"),         "value" : filterPopupCurrentRow.ITENS_AF == 'N'   ? 'Itens de AF Alterados' : "Todos os Itens de AF" },
            { "label": ScreenService.i18n("Comprador"),        "value" : concatArrayForParams(filterPopupCurrentRow.CDOPERADOR, 'Todos')},
            { "label": ScreenService.i18n("Fornecedor"),       "value" : concatArrayForParams(filterPopupCurrentRow.CDFORNECED, 'Todos')},
            { "label": ScreenService.i18n("Unidade Destino"),  "value" : owner.getField('CDFILIAL').readOnly ? getLocalVar('CDFILIAL') : concatArrayForParams(filterPopupCurrentRow.CDFILIAL, 'Todas')}
        ];
	    
    };
    
    this.filtrar = function (args){
	        
        var widget = args.owner;
        var filterRow = args.e.preference.FILTER_ROW;
        this.cleanEmptyAfFilterOnFilterPopup(args);
        if(widget.dataSourceFilter){
            widget.dataSourceFilter = [];    
        }
        this.setWidgetAfFilterBySelectedAfOnFilterPopup(args);
        //this.setComponentAfFilter(args, widget);
        
        self.transformaData(filterRow);
        
        if(typeof(filterRow) === 'object'){
            args.e.preference.CUSTOM_FILTER_ROW = {
                "P_IDSITUACAO" : filterRow.NMTPAF            ? filterRow.NMTPAF                     : 'A_M',
                "P_DTAFINI"    : filterRow.DATA_AF && filterRow.DATA_AF.start && filterRow.DATA_AF.end ? filterRow.DATA_AF.start : null,
                "P_DTAFFIN"    : filterRow.DATA_AF && filterRow.DATA_AF.start && filterRow.DATA_AF.end ? filterRow.DATA_AF.end : null,
                "P_DTENTINI"   : filterRow.DATA_ENTREGA && filterRow.DATA_ENTREGA.start && filterRow.DATA_ENTREGA.end ? filterRow.DATA_ENTREGA.start : null,
                "P_DTENTFIN"   : filterRow.DATA_ENTREGA && filterRow.DATA_ENTREGA.start && filterRow.DATA_ENTREGA.end ? filterRow.DATA_ENTREGA.end : null,
                "P_CDAGRUPFILI": filterRow.CDGRUPFILI ? filterRow.CDGRUPFILI                        : "",
                "P_PRODINI"    : filterRow.CDPRODUTO_INICIAL ? filterRow.CDPRODUTO_INICIAL          : "",
                "P_PRODFIN"    : filterRow.CDPRODUTO_FINAL   ? filterRow.CDPRODUTO_FINAL            : "",
                "P_AUTOFORNE"  : concatArrayForParams(filterRow.NRAUTOFORN),
                "P_TITENS"     : filterRow.ITENS_AF          ? filterRow.ITENS_AF                   : "S",
                
                "P_TPROD"      : (!(filterRow.CDPRODUTO_INICIAL && filterRow.CDPRODUTO_FINAL)) ? "T": "",
                "P_TDTAF"      : filterRow.DATA_AF && filterRow.DATA_AF.start && filterRow.DATA_AF.end ? null : 'T',
                "P_TDTENT"     : filterRow.DATA_ENTREGA && filterRow.DATA_ENTREGA.start && filterRow.DATA_ENTREGA.end ? null : 'T',
                "P_COMPRADOR"  : concatArrayForParams(filterRow.CDOPERADOR),
                "P_FORNECEDOR" : concatArrayForParams(filterRow.CDFORNECED),
                "P_CDFILDEST"  : widget.getField('CDFILIAL').readOnly ? getLocalVar('CDFILIAL') : concatArrayForParams(filterRow.CDFILIAL) 
            };
        }
	    
    };
    
    self.transformaData = function(filterRow){
        if(!filterRow.DATA_AF){
            filterRow.DATA_AF = {'start': "", 'end': ""};
        }
        
        if(!filterRow.DATA_ENTREGA){
            filterRow.DATA_ENTREGA = {'start': "", 'end': ""};
        }
    };
    
    /**
     * Define o filtro do componente relacionado
     * a AF's de acordo com os outros valores 
     * inseridos no popup(filtro).
     * 
     * os filtros são montados com 4 
     * propriedades, ás comuns: name, operator, value,
     * e uma quarta propriedadade(defaultValue)
     * para quando o valor principal for nulo,
     * este valor assumirá o valor do filtro.
     * 
     * @param {object} component component que irá
     * receber os filtros.
     * 
     * @param {boolean} reloadComponent valor lógico indicando se 
     * o função deve ou não atualizar o componente em caso.
    */
    this.setComponentAfFilter = function(args, component, reloadComponent){
        
        var filterPopupCurrentRow = args.row;
        var cdforneced = filterPopupCurrentRow.CDFORNECED ? filterPopupCurrentRow.CDFORNECED : 'T';
        var cdoperador = filterPopupCurrentRow.CDOPERADOR ? filterPopupCurrentRow.CDOPERADOR : 'T';
        // var cdproduto_final = filterPopupCurrentRow.CDPRODUTO_FINAL ? filterPopupCurrentRow.CDPRODUTO_FINAL : "";
        
        var fieldsToFilterTheAfField = [
            {
                name: "P_FORNECEDOR",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(cdforneced)
            },
            {
                name: "P_COMPRADOR",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(cdoperador)
            },
            {
                name: "P_CDFILDEST",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.CDFILIAL)
            },
            {
                name: "P_IDSITUACAO",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.NMTPAF, 'A_M')
            },
            {
                name: "P_DTAFINI",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.DATA_AF.start, "")
            },
            {
                name: "P_DTAFFIN",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.DATA_AF.end, "")
            },
            {
                name: "P_TDTAF",
                operator: "=",
                value: (filterPopupCurrentRow.DATA_AF) ? 'T': ""
            },
            {
                name: "P_DTENTINI",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.DATA_ENTREGA.start, "")
            },
            {
                name: "P_DTENTFIN",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.DATA_ENTREGA.end, "")
            },
            {
                name: "P_TDTENT",
                operator: "=",
                value: (filterPopupCurrentRow.DATA_ENTREGA) ? 'T': ""
            },
            {
                name: "P_CDAGRUPFILI",
                operator: "=",
                value: ""
            },
            {
                name: "P_PRODINI",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.CDPRODUTO_INICIAL, "")
            },
            {
                name: "P_PRODFIN",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.CDPRODUTO_FINAL, "")
            },
            {
                name: "P_TPROD",
                operator: "=",
                value: (!(filterPopupCurrentRow.CDPRODUTO_INICIAL && filterPopupCurrentRow.CDPRODUTO_FINAL)) ? 'T': ""
            },
            {
                name: "P_AUTOFORNE",
                operator: "=",
                value: 'T'
            },
            {
                name: "P_TITENS",
                operator: "=",
                value: filterPopupCurrentRow.ITENS_AF ? filterPopupCurrentRow.ITENS_AF : "S"
            }
        ];
        
        fieldsToFilterTheAfField.forEach(function(filter){
            component.dataSourceFilter = this.setFilterOnComponent(component, filter);
        }.bind(this));
        
        if(Boolean(reloadComponent)){
            component.reload();
        }
        
        return component.dataSourceFilter;
        
    };
    
    /**
     * Define o filtro recebido como parâmetro
     * no componente também recebido como parâmetro,
     * caso um filtro com o mesmo nome seja 
     * encontrado no componente, a função apenas atualizará
     * o seu valor pelo valor do filtro recebido.
     * 
     * @param {object} component componente que receberá 
     * o filtro recebido.
     * 
     * @param {object} filter filtro que será inserido
     * no array(dataSourceFilter) da field recebida.
     * 
     * @return {object} array com os filtro configurados.
    */
    this.setFilterOnComponent = function(component, filter){
        
        var fieldFilter = component.dataSourceFilter;
        var receivedFilterIndex = this.getObjectPositionInArrayByName(fieldFilter, filter.name);
        
        if(!Util.isUndefined(receivedFilterIndex) && Boolean(receivedFilterIndex.toString())){
            fieldFilter[receivedFilterIndex].value = filter.value;
        } else {
            fieldFilter.push(filter);
        }
        
        return fieldFilter;
        
    };
    
    /**
     * Concatena os valores do array recebido como parâmetro
     * e em uma string, separando-os com underline('_').
     * 
     * @param {object} array array com os valores a serem
     * concatenados.
     * 
     * @return {string} string com os valores do array concatenado,
     * caso o parâmetro recebido não seja um array(typeod object)
     * a função retorna o mesmo valor recebido.
    */
    
    this.conctArrayValuesWithUnderLine = function(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    };
    
    /**
     * Procedimento para recuperar a posição
     * de um objeto dentro de um array.
     * 
     * @param {object} array array onde será feito
     * a varredura.
     * 
     * @param {object} objectName nome do objeto a ser
     * buscado.
    */
    this.getObjectPositionInArrayByName = function(array, objectName){
        
        var indexFieldObject;
      
        array.forEach(function(value, i){
            if(value.name === objectName){
                indexFieldObject = i;
            } 
        });
        
        return indexFieldObject;
        
    };
    
    /**
     * Limpa a propriedade 'dataSourceFilter' do componente
     * recebido como parâmetro.
     * 
     * @param {object} component componente que terá seu
     * dataSourceFilter limpo.
    */
    this.cleanComponentDataSourceFilter = function(component){
        
        if(component.dataSourceFilter){
            component.dataSourceFilter = [];    
        }
        
    };
    
    
    /**
     * Retorna o código do produto recebido concatenado com os caracteres 'Z'.
     * O método é necessário para filtrar um periodo de produto, permitindo que
     * a query retorne os filhos daquele produto.
     * 
     * @param {string} string refernete ao código do produto
    */ 
    this.concatProductCodeWithComplementString = function(productCode){
        if(productCode){
            return productCode.padEnd(20,'Z');
        }
    };
    
    /**
     * Define um filtro na widget de AF's ("WDGT_ALTERACAO_APROVACAO_AF")
     * para exibir apenas as AF's selecionadas no popup de filtro.
     * Caso nenhuma AF tenha sido selecionada no popup de filtro
     * nenhum filtro é adicionado a widget.
     * 
     * @param {object} widget widget de AF's
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.setWidgetAfFilterBySelectedAfOnFilterPopup = function(args){
        
        var filterPopupCurrentRow = args.e.preference.FILTER_ROW;
        var valuesToFilterWidget = ["CDFILDEST", "CDFILLANC", "NRAUTOFORN"];
        
        if(Boolean(filterPopupCurrentRow.CDFILLANC) && typeof filterPopupCurrentRow.CDFILLANC === "object" && filterPopupCurrentRow.CDFILLANC.length > 0){
            
            valuesToFilterWidget.forEach(function(valueToFilter){
                
                var filter = {name: valueToFilter, operator: "IN", value: filterPopupCurrentRow[valueToFilter]};
                args.owner.dataSourceFilter = this.setFilterOnComponent(args.owner, filter); 
                
            }.bind(this));
            
        } else {
            this.cleanEmptyAfFilterOnFilterPopup(args);
        }
        
    };
    
    /**
     * Limpa o filtro da widget recebida como parâmetro
     * relacionado a AF.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.cleanEmptyAfFilterOnFilterPopup = function(args){
        
        var widgetFilter = args.owner.dataSourceFilter;
        var filterPopupCurrentRow = args.e.preference.FILTER_ROW;
        var cdfillanc = filterPopupCurrentRow.CDFILLANC ? filterPopupCurrentRow.CDFILLANC : "";
        
        if(Boolean(cdfillanc)){
            
            var afValueOnFilter = filterPopupCurrentRow.CDFILLANC;
            
            if((typeof afValueOnFilter === 'object' && afValueOnFilter.length === 0) || !afValueOnFilter){
                
                delete filterPopupCurrentRow.CDFILLANC;
                
                widgetFilter.forEach(function(filter, index){
                    
                    if(filter.name === "CDFILLANC"){
                        owner.dataSourceFilter.splice(index, 0);
                    }    
                    
                });
                
            }    
            
        }
        
    };
    
    /**
     * Retorna a data recebida como parâmetro em um objecto
     * moment.
     * 
     * @param {string} date data que será retornada.
     * 
     * @param {format} format formato da data recebida e
     * que será retornada.
     * 
     * @return {object} objeto moment com a data recebida.
    */
    this.changeDateToMomentObject = function(date, format){
        return moment(date, format);
    };
    
    /**
     * Busca os parâmetros gerais do sistema.
     * 
     * @param {object} widget widget principal
     * da tela, ("WDGT_ALTERACAO_APROVACAO_AF")
     * que irá receber os parâmetros buscados.
    */
    this.getParamGeralIdsisdos = function(widget){
        
        General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/getSystemParamGeral', "Row", widget.currentRow).then(function(response){
            widget.PARAMGERAL = response.dataset.PARAMGERAL[0];
            this.validaFiltro(widget);
        }.bind(this))
        .catch(function(error){
            ScreenService.showMessage(error.data.error);
        });
        
    };
    
    
    /**
     * Retorna os tipos de af selecionados no popup do filtro.
     * 
     * @return {string} tipo de AF selecionado no filtro.
    */
    this.getAfTypeOnFilterPopupCurrentRow = function(owner){
        
        var filterPopupCurrentRow = owner.appliedFilter.FILTER_ROW;
        var selectedAfTypes = filterPopupCurrentRow.NMTPAF;
            
        if(selectedAfTypes === 'A'){
            return ScreenService.i18n("Automática");
        }else  if(selectedAfTypes === 'M'){
            return ScreenService.i18n("Manual");
        }
        
    };
    
    /**
     * concatena um valor na propriedade 'label' do campo recebido como parâmetro
     * (presente em uma widget stripe) após encontrado dois pontos(':') na mesma label.
     * 
     * @param {object} stripeField field que terá sua label modificada.
     * 
     * @param {string} valueToConcat valor que será concatenado na label do campo recebido
     * como parâmetro.
     * 
    */
    this.concatValueToStripeFieldLabelAfterColon = function(stripeField, valueToConcat){
        
        var fieldLabel = stripeField.label;
        var colonIndex = fieldLabel.indexOf(':');
        var defaultFieldValue = fieldLabel.substr(0, colonIndex + 2);
        
        if(valueToConcat){
            stripeField.label = defaultFieldValue + (Array.isArray(valueToConcat) ? valueToConcat.join(', ') : valueToConcat);
        } else {
            stripeField.label = defaultFieldValue;
        }
        
    };
    
    /**
     * Define dois campos relacionados como obrigatório caso um esteja preenchido
     * na currentRow da widget recebida como parâmetro.
     * 
     * @param {object} widget widget onde estão localizados os campos recebidos
     * como parâmetro.
     * 
     * @param {object} field primeiro campo da relação.
     * 
     * @param {obbject} referenceField segundo campo da relação.
    */
    this.setRelatedFieldsAsRequired = function(widget, field, referenceField){
        
        var currentRow = widget.currentRow;
        
        if(Boolean(currentRow[field.name]) || Boolean(currentRow[referenceField.name])){
            
            this.setFieldRequireValidation(field, true);
            this.setFieldRequireValidation(referenceField, true);
            
        } else {
            
            this.setFieldRequireValidation(field, false);
            this.setFieldRequireValidation(referenceField, false);
            
        }
        
    };
    
    /**
     * Retorna o tipo de itens selecionado no
     * filtro, referente ao código dos mesmos
     * definidos no pŕoprio JSON do campo.
     * 
     * @return {string} nome referente ao tipo 
     * selecionado.
    */
    this.getSelectedItemTypeOnFilter = function(owner){
        
        var filterPopupCurrentRow = owner.appliedFilter.FILTER_ROW;
        var selectedItemType = filterPopupCurrentRow.ITENS_AF;
        
        if(selectedItemType === 'S'){
            return ScreenService.i18n("Todos os Itens da AF");
        } else if(selectedItemType === 'N'){
            return ScreenService.i18n("Itens da AF Alterados");
        }
        
    };
    
    /**
     * Retorna dois valores referentes a um intervalor
     * presente no filtro.
     * 
     * @param {string} valueIni valor do campo referente ao inicio
     * do intervalo.
     * 
     * @param {string} valueEnd valor do campo referente ao final do
     * intervalo.
     * 
     * @param {string} separator string que irá ser concatenada entre os dois valores.
     * 
     * @return {string} valores concatenados com o separador.
    */
    this.returnRangeOnFilter = function(valueIni, valueEnd, separator){
        
        if(valueIni && valueEnd) {
            return valueIni + separator + valueEnd;
        } else {
            return "";
        }
        
    };
    
    /**
     * Define se um campo será obrigatório pelo valor
     * lógico(isRequired) recebido como parâmetro.
     * 
     * @param {object} field campo que terá sua validação definida.
     * 
     * @param {boolean} isRequired valor lógico indicando se o campo
     * será obrigatório ou não.
    */
    this.setFieldRequireValidation = function(field, isRequired){
        
        if(isRequired){
            field.validations.required = true;
        } else {
            delete field.validations.required;
        }
        
    };
    
    this.backGridPrincipal = function(widget) {
        if (this.isGrSystem()) {
            const widgetProdutos = widget.container.getWidget("WDGT_PRODUTOS_AF");
            this.notifiesAfResponsibleAboutProductEditing(widgetProdutos);
        }
        
        General.widgetGoBackToList(widget);
        widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF').activate();
    };
    
    this.backGridProdutos = function(widget){
        General.widgetGoBackToList(widget);
        widget.activate();
    };
    
    /**
     * Função para definir o filtro dos campos referente ao
     * renge de produto presentes no popup do filtro.
     * Se um campo estiver preenchido, o outro campo, referente,
     * e filtrado.
     * 
     * O código do produto final deve ser obrigatoriamente menor
     * do que o código do produto inicial.
    */
    this.setProductIntervalFilterOnFilterPopup = function(args, field){
        
        var filterPopupCurrentRow = args.row;
        if(!(self.validaProduto(filterPopupCurrentRow.CDARVPROD_INICIAL, filterPopupCurrentRow.CDARVPROD_FINAL))){
            if(field.name == 'NMPRODUTO_INICIAL'){
                filterPopupCurrentRow.CDPRODUTO_INICIAL = '';
                filterPopupCurrentRow.NMPRODUTO_INICIAL = '';
            }else{
                filterPopupCurrentRow.CDPRODUTO_FINAL = '';
                filterPopupCurrentRow.NMPRODUTO_FINAL = '';
            }
        }
        // var iniProductField = widget.getField("NMPRODUTO_INICIAL");
        // var endProductField = widget.getField("NMPRODUTO_FINAL");
        
        // var filter, valueFilter;
        // if(Boolean(filterPopupCurrentRow.CDPRODUTO_INICIAL)){
            
        //     valueFilter = filterPopupCurrentRow.CDPRODUTO_INICIAL;
        //     filter = {name: "CDPRODUTO", operator: ">=", value: valueFilter};
        //     endProductField.dataSourceFilter = this.setFilterOnComponent(endProductField, filter);
            
        //     endProductField.reload();
            
        // } else {
        //     this.deleteComponentFilterByName(endProductField, "CDPRODUTO");
        //     endProductField.reload();
        // }
        // if(Boolean(filterPopupCurrentRow.CDPRODUTO_FINAL)){
            
        //     valueFilter = filterPopupCurrentRow.CDPRODUTO_FINAL;
        //     filter = {name: "CDPRODUTO", operator: "<=", value: valueFilter};
        //     iniProductField.dataSourceFilter = this.setFilterOnComponent(iniProductField, filter);
            
        //     iniProductField.reload();
            
        // }else {
        //     this.deleteComponentFilterByName(iniProductField, "CDPRODUTO");
        //     iniProductField.reload();
        // }
        
    };
    
    /**
     * Remove um objeto presente no array de filtros ('dataSourceFilter'),
     * do componente recebido como parâmetro, pelo nome recebido como parâmetro.
     * 
     * @param {object} component componente que terá seu filtro modificado.
     * 
     * @param {string} filterName nome do objeto a ser removido do componente.
    */
    this.deleteComponentFilterByName = function(component, filterName){
        
        var componentFilter = component.dataSourceFilter;
        
        componentFilter.forEach(function(filter, index){
           
           if(filter.name === filterName){
               component.dataSourceFilter.splice(index, 1);
           }
            
        });
        
    };
    
    /**
     * Limpa um valor na currentRow do popup do filtro pelo nome
     * recebido como parâmetro.
     * 
     * @param {string} valueName nome da propriedade que irá ser limpa
     * na currentRow do filtro.
    */
    /*
    this.cleanValueOnFilterPopupCurrentRowByName = function(valueName){
        
        var filterPopupCurrentRow = this.getFilterPopupCurrentRow();
        
        filterPopupCurrentRow[valueName] = "";
        
    };
    */
    
    /**
     * Executa os eventos definidos na função no evento
     * 'WidgetAfterMoveRow' da widget recebida como
     * parâmetro.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.productWidgetAfterMoveRow = function(widget){
        if (this.isGrSystem()) {
            const widgetProdutos = widget.container.getWidget("WDGT_PRODUTOS_AF");
            this.notifiesAfResponsibleAboutProductEditing(widgetProdutos);
        }
        
        this.getCurrentAfInfosAndSetOnWidget(widget);
        this.controlActionsProduct(widget);
    };
    
//=====================================================================================================================
// WIDGET AF PRODUCT'S
    
    /**
     * Define o filtro da widget de produtos da af
     * pela AF selecionada.
     * 
     * @param {object} widget widget de produtos de af
     * ("WDGT_PRODUTOS_AF");
     * 
     * @param {string} cdgrup parametro que verifica se produto pode aumentar preço.
     * 
     * @param {string} cdsubgrup parametro que verifica se produto pode aumentar preço.
    */
    this.setWidgetAfProductsFilter = function(widget, cdgrup, cdsubgrup){
        
        var parentWidgetCurrentRow = widget.getParent().currentRow;
        
        var fieldsToFilterAfProductsWidget = [
            {
                name: "P_CDFILDEST",
                operator: "=",
                value: parentWidgetCurrentRow.CDFILDEST,
                defaultValue: ""
            },
            {
                name: "P_CDFILLANC",
                operator: "=",
                value: parentWidgetCurrentRow.CDFILLANC,
                defaultValue: ""
            },
            {
                name: "P_NRAUTOFORN",
                operator: "=",
                value: parentWidgetCurrentRow.NRAUTOFORN,
                defaultValue: ""
            },
            {
                name: "P_CDGRUPPROD",
                operator: "=",
                value: cdgrup,
                defaultValue: ""
            },
            {
                name: "P_CDSUBGRPROD",
                operator: "=",
                value: cdsubgrup,
                defaultValue: ""
            }
        ];
        
        fieldsToFilterAfProductsWidget.forEach(function(filter){
            widget.dataSourceFilter = fieldsToFilterAfProductsWidget;
        }.bind(this));
        
        widget.reload();
        
    };
    
    /**
     * Busca as informações necessárias sobre a AF selecionda,
     * Operador da unidade, Periodicidade, Integração e Central
     * de vendas. Com essas informações, chama o método que
     * monta o filtro para a tela de produtos.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.getCurrentAfInfosAndSetOnWidget = function(widget){
        
        var currentRow = widget.currentRow;
        currentRow.CDFILCENTCMP = widget.appliedFilter.FILTER_ROW.CDFILIAL.join('_');
        var widgetProdutosAf = widget.container.getWidget('WDGT_PRODUTOS_AF');
        
        this.setIdSisDosOnCurrentRow(widget);
        
        General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/getCurrentAfInfos", "Row", currentRow).then(function(response){
            var afInfos = response.dataset.AF_INFOS[0];
            
            if (!afInfos.PERMISSIONS.length) {
                widgetProdutosAf.getAction("INCLUIR_PRODUTO").isVisible = false;
            }
            else {
                  widgetProdutosAf.getAction("INCLUIR_PRODUTO").isVisible = true;
            }
            
                var cdGrupProd = afInfos.PERMISSIONS.length ? afInfos.PERMISSIONS[0].CDGRUPPROD : false;
                var cdSubGrupProd = afInfos.PERMISSIONS.length ? afInfos.PERMISSIONS[0].CDSUBGRUPPROD : false;
                widget.PERMISSIONS = afInfos.PERMISSIONS;
                widget.OPERADORES_UNIDADE = afInfos.BRANCH_OPERATOR;
                widget.PERIODICIDADE = afInfos.FREQUENCY;
                widget.INTEGRACAO = Boolean(afInfos.INTEGRATION[0]) ? afInfos.INTEGRATION[0].CDFILDEST : "";
                widget.CENTRAL_VENDA = afInfos.TRADING_CENTER;
                
                this.setWidgetAfProductsFilter(widgetProdutosAf, cdGrupProd, cdSubGrupProd);
                this.setProductWidgetFooterInfos(widget);
            
        }.bind(this))
        .catch(function(error){
            ScreenService.showMessage(error.data.error);
        });
        
    };
    
    /**
     * Seta o parâmetro "IDSISDOS" na currentRow
     * da widget recebida como parâmetro.
     * 
     * @param {object} widget widget que receberá,
     * em sua currentRow, o parâmetro "IDSISDOS".
    */
    this.setIdSisDosOnCurrentRow = function(widget){
        
        var paramGeral = this.getGeralParam();
        
        widget.currentRow.IDSISDOS = paramGeral.IDSISDOS;
        
    };
    
    /**
     * Exibe no footer da widget de produtos, a situação/limite
     * e a periodicidade da AF selecionada.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.setProductWidgetFooterInfos = function(widget){
        
        var productFooter = templateManager.container.getWidget("WDGT_STRIPE_FOOTER_PRODUTO");
        var productFooterFields = productFooter.fields;
        
        var situacaoLimiteFieldIndex = this.getObjectPositionInArrayByName(productFooterFields, "SITUACAO_LIMITE");
        var fieldSituacaoLimite = productFooterFields[situacaoLimiteFieldIndex];
        this.concatValueToStripeFieldLabelAfterColon(fieldSituacaoLimite, widget.currentRow.DSINCONSAF);
        //this.concatValueToStripeFieldLabelAfterColon(fieldSituacaoLimite,widget.container.getWidget('WDGT_PRODUTOS_AF').currentRow.DSINCONSITAF);
        var periodicidadeFieldIndex = this.getObjectPositionInArrayByName(productFooterFields, "PERIODICIDADE");
        var fieldPeriodicidade = productFooterFields[periodicidadeFieldIndex];
        this.concatValueToStripeFieldLabelAfterColon(fieldPeriodicidade, this.getAfFrequency(widget));
        
    };
    
    this.informaInconsistenciaItemAF = function() {
        
        let rowProduto = templateManager.container.getActiveWidget().currentRow;
        
        ScreenService.showMessage(rowProduto.DSINCONSITAF);
    };
    
    this.abreSituacao = function () {
        const widgetSituacao        = templateManager.container.getWidget('situacao');
        const alteracaoAprovacaoRow = templateManager.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF').currentRow;
        
        widgetSituacao.dataSourceFilter = [
            {"name": "CDFILLANC",    "value": alteracaoAprovacaoRow.CDFILLANC,   "operator": "="},
            {"name": "CDFILDEST",    "value": alteracaoAprovacaoRow.CDFILDEST,   "operator": "="},
            {"name": "NRAUTOFORN",   "value": alteracaoAprovacaoRow.NRAUTOFORN,  "operator": "="},
            {"name": "CDPRODUTO",    "value": null,                              "operator": "="},
            {"name": "CDMARCA",      "value": null,                              "operator": "="},
            {"name": "DTPROGENTAF",  "value": alteracaoAprovacaoRow.DTPROGENTAF, "operator": "="},
            {"name": "CDFILCENT",    "value": CDFILCENTCMP,       "operator": "="},
            {"name": "NRORG",        "value": getLocalVar("NRORG"),              "operator": "="}
        ];
        ScreenService.openPopup(widgetSituacao);
    };
    
    this.backPopupSituacao = function () {
        const alteracaoAprovacaoWid = templateManager.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
        const produtoWid            = templateManager.container.getWidget('WDGT_PRODUTOS_AF');
        
        ScreenService.closePopup();
    };
    
    /**
     * Retorna a periodicidade da AF selecionada.
     * 
     * @param {object} widget widget principal
     * da tela ("WDGT_ALTERACAO_APROVACAO_AF").
     * 
     * @return {string} periodicidade da AF
     * em caso.
    */
    this.getAfFrequency = function(widget){
        
        if(Boolean(widget.PERIODICIDADE) && this.isObject(widget.PERIODICIDADE) && widget.PERIODICIDADE.length > 0){
            return widget.PERIODICIDADE[0].CDPERIENTR + " " + widget.PERIODICIDADE[0].NMPERIENTR;
        } else {
            return "Livre";
        }
        
    };
    
   /*  this.controlaSituacaoAf = function(widget) {
        var produto = widget.container.getWidget('WDGT_PRODUTOS_AF');
        produto.dataSource.data.forEach(function(item) {
            if(!item.DSINCONSITAF) {
              produto.getAction('situacao').isVisible = false;
              produto.getAction('situacao').showAsAction = "";
              
            }
            else {
            produto.getAction('situacao').isVisible = true;
            produto.getAction('situacao').showAsAction = "grid_left";
            }
        });
        //produto.redraw();
        produto.activate();
    };*/
    
    /**
     * Retorna os parâmetros gerais
     * do sistema presente na widget
     * principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.getGeralParam = function(){
        
        var mainWidge = templateManager.container.getWidget("WDGT_ALTERACAO_APROVACAO_AF");
        return mainWidge.PARAMGERAL;
        
    };
    
    /**
     * Retorna um valor lógico indicando
     * se o tipo do elemento recebido
     * como parâmetro é um objeto.
     * 
     * @param {*} element elemento a ser
     * inspecionado.
     * 
     * @return {boolean} valor lógico
     * indicando se o elemento recebido
     * é um objecto.
    */
    this.isObject = function(element){
        return typeof element === "object";  
    };
    
    /**
     * Abre um swipe para adicionar novos produtos,
     * 
     * @param {object} tabbedWidget widget de produtos.
    */
    this.addProduct = function(tabbedWidget){
        ScreenService.openSwipe(tabbedWidget).then(function(){
            tabbedWidget.currentWidget.newRow();
            tabbedWidget.currentWidget.activate();
        });
    };
    
    /**
     * Habilita o ambiente de edição
     * de um produto.
     * 
     * @param {object} widget widget de 
     * produtos.
    */
    this.editProduct = function(widget){
        
        General.widgetEdit(widget);    
        
        this.setProductDefaultValues(widget);
        this.setPermissionsJustificationFields(widget, true);
    };
    
    /**
     * Define os valores padrão para a edição de
     * um produto.
     * 
     * @param {object} widget widget de produtos.
    */
    this.setProductDefaultValues = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.__is_new = false;
        currentRow.TIPOJUSTI = "S";
        currentRow.DSJUSTITMAFRPV = "";
        currentRow.IDTIPOLANITM = "M";
        currentRow.CDOPERADORITMAF = getLocalVar("CDOPERADOR");
        
    };
    
    /**
     * Aplica as regras no campo data de entrega, são elas:
     * A data nova não pode ser maior que o campo “Entrega Original",
     * A data nova não pode ser menor que a data atual,
     * A data nova não pode ser diferente da data que retornar na procedure  CARREGA_PERIFORN.
     * Casa seja, a função limpa o campo "Data de Entrega".
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.validateDeliveryDate = function(widget){
        
        var currentRow = widget.currentRow;
        delete currentRow.__rightActions;
        delete currentRow.__leftActions;
        var alterApprovWidgetCurrentRow = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF').currentRow;
        var message;
       
        if(Boolean(currentRow.DTNOVAENTRAF)){
            
            var deliveryDateWithMomentInstance       = this.changeDateToMomentObject(currentRow.DTNOVAENTRAF, "DD/MM/YYYY");
            var originDeliveryDateWithMomentInstance = this.changeDateToMomentObject(currentRow.DTPROGITMAF, "DD/MM/YYYY");
            var currentDateWithMomentInstance        = this.changeDateToMomentObject(this.getCurretDate(), "DD/MM/YYYY");
            
            currentRow.CDFORNECED = alterApprovWidgetCurrentRow.CDFORNECED;
            
            if(widget.name === 'WDGT_INSERT_PRODUTOS_AF'){
                
                var afDateWithMomentInstance = this.changeDateToMomentObject(alterApprovWidgetCurrentRow.DTAUTOFORN, "DD/MM/YYYY");
                currentRow.CDFILDEST = alterApprovWidgetCurrentRow.CDFILDEST;
                
                if(!this.checkParamAfForDeliveryDate(alterApprovWidgetCurrentRow.IDGERAFDTENT, widget, currentRow)){
                    
                    return false;
                    
                } else if (deliveryDateWithMomentInstance < afDateWithMomentInstance){
                    
                    message = "Operação bloqueada!<br/><br/>Data de entrega do produto deve ser maior que a Data da AF.";
                    this.cleanNewDateDeliveryFieldAndShowMessage(widget, message);
                    
                    return false;
                    
                }
                
            } else if(deliveryDateWithMomentInstance > originDeliveryDateWithMomentInstance){
                
                message = "Operação bloqueada!<br/><br/>Data de entrega do produto deve ser menor que a Data de Entrega Original.";
                this.cleanNewDateDeliveryFieldAndShowMessage(widget, message);
                
                return false;
            }
        
            if (deliveryDateWithMomentInstance < currentDateWithMomentInstance){
                
                message = "Operação bloqueada!<br/><br/>Data de Entrega do Produto deve ser maior que a data atual.";
                this.cleanNewDateDeliveryFieldAndShowMessage(widget, message);
                
            } else {
                
                this.executeProcedureCarregaPeriforn(currentRow).then(function(response){
                    
                    response = this.changeDateToMomentObject(response, "DD/MM/YYYY");
                    
                    var responseWithBrazilianDateFormat = this.convertMomentInstanceToBrazilianDateFormat(response);
                    var deliveryDateWithBrazilianDateFormat = this.convertMomentInstanceToBrazilianDateFormat(deliveryDateWithMomentInstance);
                    
                    if(responseWithBrazilianDateFormat !== deliveryDateWithBrazilianDateFormat){
                        
                        message = "Operação bloqueada!<br/><br/>Fornecedor não atende a data de entrega informada devido à sua periodicidade.";
                        this.cleanNewDateDeliveryFieldAndShowMessage(widget, message);
                        
                    } else {
                    
                        if(widget.name === 'WDGT_INSERT_PRODUTOS_AF'){
                            
                            this.checkBestPrice(widget);
                            
                        }
                    
                    }
                    
                }.bind(this));
                
            }
            
        }
        
    };
    
    /**
     * Retorna a data relacionada a instância "moment", recebida como parâmetro, no formato
     * brasileiro.
     * 
     * @param {object} dateAsMomentInstance instância moment que será convertida.
     * 
     * @return {string} instância moment convertida no formato de data brasileiro.
    */
    this.convertMomentInstanceToBrazilianDateFormat = function(dateAsMomentInstance){
        return dateAsMomentInstance.format("DD/MM/YYYY");  
    };
    
    /**
     * Limpa a propriedade "DTNOVAENTRAF" da currentRow recebida como parâmetro,
     * e logo em seguida exibe uma mensagem ao usuário.
     * 
     * @param {object} currentRow currentRow que terá a propriedade limpa.
     * 
     * @param {string} message menssagem que será exibida ao usuário logo após a
     * propriedade ser limpa.
    */
    this.cleanNewDateDeliveryFieldAndShowMessage = function(widget, message){
        const field = widget.getField('DTNOVAENTRAF');
        field.clearValue(field);
        ScreenService.showMessage(message);
    };

    /**
     * Retorna a data atual.
    */
    this.getCurretDate = function(){
        return moment().format("DD/MM/YYYY");
    };
    /**
     * Executa a procedure CARREGA_PERIFORN e retorna uma data
     * relacionada a periodicidade referente ao fornecedor da
     * AF em caso.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.executeProcedureCarregaPeriforn = function(currentRow){
        
        return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/executeProcedureCarregaPeriforn", "Row", currentRow).then(function(response){
            
            return response.dataset.DATA.RETURNED_DATE;
            
        })
        .catch(function(error){
            ScreenService.showMessage(error.data.error);
        });
        
    };
    
    /**
     * Retorna um valor lógico indicando se o campo "Data de Entrega"
     * está vazio e anteriormente estava preenchido.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS").
    */
    this.checkDeliveryDateOldValueAndApplyRule = function(widget){
        
        var backUpCurrentRow = widget.backupRow;
        var currentRow = widget.currentRow;
        
        if(Boolean(backUpCurrentRow.DTNOVAENTRAF) && !Boolean(currentRow.DTNOVAENTRAF)) {
            MessageService.showMessageByCode("OPR_BLOCK_DTA_ENTREGA");
            return false;
            
        } else {
            return true;
        }
        
    };
    
    /**
     * Retorna um valor lógico indicando se o campo "Qtde."
     * está vazio e anteriormente estava preenchido.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS").
    */
    this.checkAmountOldValueAndApplyRule = function(widget){
        
        var backUpCurrentRow = widget.backupRow;
        var currentRow = widget.currentRow;
        
        if(Boolean(backUpCurrentRow.QTNOVAPROGAF) && !Boolean(currentRow.QTNOVAPROGAF)) {
            MessageService.showMessageByCode("OPR_BLOCK_QTD_NEW");
            return false;
        } else {
            return true;
        }
        
    };
    
    /**
     * Verifica se a nova quantidade informada ("QTNOVAPROGAF") é maior que a 
     * quantidade de origem ("QTORIG"), case seja, a função limpa o campo e exibe
     * uma mensagem para o usuário.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF").
    */
    this.checkIfCurrentAmountIsBiggerOriginAmountAndApplyRule = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(this.parseStringToFloat(currentRow.QTNOVAPROGAF) > this.parseStringToFloat(currentRow.QTORIG) && !currentRow.ALTERAQTDE){
            
            currentRow.QTNOVAPROGAF = "";
            MessageService.showMessageByCode("OPR_BLOCK_QTD_MENOR_QTDORI");
        } else {
            if(!this.verifyMaxValue(currentRow.QTNOVAPROGAF)){
                currentRow.QTNOVAPROGAF = "";
                MessageService.showMessageByCode("OPR_BLOCK_QTD_EXCEDENTE");
            } else {
                this.checkInputtedNewDeliveryDateAndNewAmountOnCurrentRow(widget);
            }
        }
    };
    
    /**
     * Recebe um valor numérico e veriica se o mesmo é maior que o permitido, caso seja,
     * bloqueia o procedimento
     * @param {string} string com um valor numérico
    */
    
    this.verifyMaxValue = function(value){
        var maxValue = '9999999.99';
        
        if(typeof(value) == 'string'){
            value = value.split('.').join('');
            value = value.replace(',', '.');
        } 
        
        if(value && parseFloat(value) > parseFloat(maxValue)){
            return false;
        }
        return true;
    };
    
    /**
     * Trata o valor numerico dos campos verificando se os valores são maiores que o permitido, caso seja,
     * bloqueia o procedimento
     * @param {string} string com um valor numérico
    */
    
    this.verifyFieldMaxValuePreco = function (widget) {
        if(this.verifyMaxValue(widget.currentRow.VRPREUNIAF) == false){
            widget.currentRow.VRPREUNIAF = '';
            MessageService.showMessageByCode("OPR_BLOCK_VLR_EXCEDENTE");
        }
    };
    
    this.verifyFieldMaxValueQtde = function (widget) {
        if(this.verifyMaxValue(widget.currentRow.QTNOVAPROGAF) == false){
            widget.currentRow.QTNOVAPROGAF = '';
            MessageService.showMessageByCode("OPR_BLOCK_VLR_EXCEDENTE");
        }
    };
    
    /**
     * Recebe um valor numérico e veriica se o mesmo é string, caso seja,
     * retira os pontos e substitui as virgulas por pontos, convertendo para
     * float.
     * 
     * @param {string} string com um valor numérico
    */
    this.parseStringToFloat = function(value){
        
        var type = typeof value;
        
        if(type === "string"){
            value = parseFloat(value.replace('.', '').replace(',', '.'));
        }
        
        return value;
        
    };
    
    /**
     * Define se os campos relacionados a justificativa serão bloqueados
     * ou não.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF")
    */
    this.checkInputtedNewDeliveryDateAndNewAmountOnCurrentRow = function(widget){
        if(widget){
            if(this.checkNewValuesOnAfProduct(widget)){
                this.setPermissionsJustificationFields(widget, false);
            } else {
                this.setPermissionsJustificationFields(widget, true);
            }
        }
        
    };
    
    /**
     * Verifica se ouve alguma alteção no campo "Entrega"
     * e no campo "Qtd" na widget de produtos.
     * 
     * @param {object} object widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.checkNewValuesOnAfProduct = function(widget){
        
        var currentRow = this.setNullValuesToEmptyValuesOnObject(widget.currentRow, ["DTNOVAENTRAF", "QTNOVAPROGAF"]);
        var backUpCurrentRow = this.setNullValuesToEmptyValuesOnObject(widget.backupRow, ["DTNOVAENTRAF", "QTNOVAPROGAF"]);
        
        if(currentRow.DTNOVAENTRAF !== backUpCurrentRow.DTNOVAENTRAF || currentRow.QTNOVAPROGAF !== backUpCurrentRow.QTNOVAPROGAF){
            
            currentRow.EDITEDPRODUCT = true;
            return true;
            
            
        } else {
            
            currentRow.EDITEDPRODUCT = false;
            return false;
            
        }
        
    };
    
    /**
     * Verifica se no objeto recebida como parâmetro, existem os valores
     * do array, também recebido como parâmtro, como nulos.
     * 
     * @param {object} object objeto a ser verificado.
     * 
     * @param {object} arrayOfValues array com os valores a serem verificados.
    */
    this.setNullValuesToEmptyValuesOnObject = function(object, arrayOfValues){
        
        arrayOfValues.forEach(function(value){
            
            object[value] = typeof object[value] === 'number' ? object[value].toString() : object[value];
            
            if(!Boolean(object[value])){
                object[value] = "";
            }
            
        });
        
        return object;
        
    };
    
    /**
     * Define a propriedade "readOnly" da field recebida com
     * parâmetro.
     * 
     * @param {object} field field que teŕa sua propriedade
     * definida.
     * 
     * @param {boolean} isReadOnly valor lógico indicando se
     * o field será apenas leitura ou não.
    */
    this.setFieldReadOnlyProperty = function(field, isReadOnly){
        field.readOnly = isReadOnly;
    };
    
    /**
     * Define a propriedade "isVisible" da action recebida como
     * parâmetro.
     * 
     * @param {object} action action que teŕa sua propriedade
     * definida.
     * 
     * @param {boolean} isVisible valor lógico indicando se
     * a action será visivel ou não.
    */
    this.setActionVisibleProperty = function(action, isVisible){
        action.isVisible = isVisible;
    };
    
    /**
     * Define se os campos relacionados a justivicativa serão desbloqueados
     * ou não.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF"),
     * onde estão localizados os campos em questão.
    */
    this.setPermissionsJustificationFields = function(widget, isLocked){
        
        var currentRow = widget.currentRow;
        
        var justificationType = widget.getField("TIPOJUSTI");
        var justificationSelectField = widget.getField("DSJUSTITMAF");
        
        if(isLocked){
            
            this.setFieldRequireValidation(justificationSelectField, false);   
            this.setFieldReadOnlyProperty(justificationSelectField, true);
            this.setFieldReadOnlyProperty(justificationType, true);
            currentRow[justificationSelectField.name] = "";
            
        } else {
            
            this.setFieldRequireValidation(justificationSelectField, true);   
            this.setFieldReadOnlyProperty(justificationSelectField, false);
            this.setFieldReadOnlyProperty(justificationType, false);
            
        }
      
    };
    
    /**
     * Define o template do campo de justificativa através
     * do valor informado no campo tipo justificativa
     * ("TIPOJUSTI").
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.setJustificationFieldTemplate = function(widget){
        
        var currentRow = widget.currentRow;
        
        var justificationField = widget.getField("DSJUSTITMAF");
        
        if(currentRow.TIPOJUSTI === "S"){
            this.setFieldTemplate(justificationField, "field/select.html");
        } else {
            this.setFieldTemplate(justificationField, "field/text-edit.html");
            justificationField.maxlength = 100;
        }
        justificationField.reload();
        
        
    };
    
    /**
     * Define o templete da field recebido como parâmetro
     * para o template também recebido como parâmetro.
     * 
     * @param {object} field field que terá seu template
     * modificado.
     * 
     * @param {string} templateName nome do template que será
     * definido no field.
    */
    this.setFieldTemplate = function(field, templateName){
        
        field.template = templateName;
        templateManager.updateTemplate();
        
    };
    
    /**
     * Caso o sistema reconheça que o usuário logado
     * pertença ao cliente GR, o sistema verifica se
     * o parâmetro INTEGRACAO, presente na wiget principal
     * da tela, está vazio, caso esteja, o sistema não permite
     * o usuário realizar a rotina e exibe uma mensagem informando
     * o mesmo.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AG").
     * 
    */
    this.applyGRRulesToSaveByParentAfIntegration = function(widget){
        
        var parentWidget = widget.getParent();
        var zhPromise = ZHPromise.defer();
        if(this.isGrSystem()){
            
            if(!Boolean(parentWidget.INTEGRACAO)){
                return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/getParamSupplier", "Row", parentWidget.currentRow).then(function(response){
                    let param = response.dataset.PARAM;
                    if (param.USR_INTEGRAMESAP === 'S') {
                        MessageService.showMessageByCode("OPR_BLOCK_AF_N_HABILITADA");
                        return false;
                    } else if ((param.IDPERALTAFCONF === 'N') && (param.IDSITUATENDIMENTOAF != 'X')) {
                        MessageService.showMessageByCode("OPR_BLOCK_AF_N_PODE_ALTERAR");
                        return false;
                    } else {
                        return true;
                    }
                });
                
            } else {
                zhPromise.resolve(true);
                return zhPromise.promise;
            }
            
        } else {
            zhPromise.resolve(true);
            return zhPromise.promise;
        }
        
    };
    
    /**
     * Verifica se o sistema está sendo usado pelo cliente GR e se
     * o usuário está alterando, simultaneamente, a nova data de entrega
     * e a quantidade.
     * Esta validação é feita da seguinte forma, quando os campos "entrega" ou "Qtde"
     * já está preenchido, indica que ainda não ocorreu aprovação do mesmo,
     * sendo assim, o sistema deve permitir que apenas um campo seja alterado por vez.
     * Ex.:
     * O usuário solicitou a alteração da quantidade do produto(campo Qtde) e salvou no campo,
     * logo ele não pode solicitar a alteração do campo entrega enquanto a quantidade não
     * tiver recebido um feedback.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF");
    */
    this.applyGRRulesToSaveByNewAmountAndNewDeliveryDate = function(widget){
        
        var currentRowBackup = widget.backupRow;
        var currentRow = widget.currentRow;
        
        if(this.isGrSystem()){
            
            if(
                (Boolean(currentRowBackup.DTNOVAENTRAF) && Boolean(currentRow.QTNOVAPROGAF)) || 
                (Boolean(currentRowBackup.QTNOVAPROGAF) && Boolean(currentRow.DTNOVAENTRAF)) ||
                (currentRowBackup.QTNOVAPROGAF !== this.removeValueCurrencyMask(currentRow.QTNOVAPROGAF)) && (currentRowBackup.DTNOVAENTRAF !== currentRow.DTNOVAENTRAF)
            )
            {
                
                ScreenService.showMessage("Operação bloqueada.<br/><br/>Não é permitido alterar data de entrega e quantidade simultaneamente.");
                return false;
                
            } else {
                return true;
            }
            
        } else {
            return true;
        }
       
    };
    
    /**
     * APlica as regras de negócio para salvar
     * uma edição referente ao produto em caso.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.applyRulesToSaveEditing = function(widget){
        
        this.createBackupRowCopyOnWidget(widget);
        
        if(widget.isValid()){
            const situacaoWid = templateManager.container.getWidget('situacao');
            situacaoWid.dataSourceFilter = [
                {"name": "CDFILLANC",    "value": widget.currentRow.CDFILLANC,   "operator": "="},
                {"name": "CDFILDEST",    "value": widget.currentRow.CDFILDEST,   "operator": "="},
                {"name": "NRAUTOFORN",   "value": widget.currentRow.NRAUTOFORN,  "operator": "="},
                {"name": "CDPRODUTO",    "value": widget.currentRow.CDPRODUTO,   "operator": "="},
                {"name": "CDMARCA",      "value": widget.currentRow.CDMARCA,     "operator": "="},
                {"name": "DTPROGENTAF",  "value": widget.currentRow.DTPROGITMAF, "operator": "="},
                {"name": "CDFILCENT",    "value": CDFILCENTCMP,   "operator": "="},
                {"name": "NRORG",        "value": getLocalVar("NRORG"),          "operator": "="}
            ];
            situacaoWid.reload().then(function(callback) {
                if(situacaoWid.dataSource.data.length > 0) {
                    ScreenService.openPopup(situacaoWid);
                    MessageService.showMessageByCode("DADOS_INCONSISTENTES_AF");
                    widget.currentRow.__is_new = false;
                    situacaoWid.widgetAlterada = widget;
                } else {
                    self.applyGRRulesToSaveByParentAfIntegration(widget).then(function(response){
                        if(response){
                            
                            if(self.applyGRRulesToSaveByNewAmountAndNewDeliveryDate(widget)){
                                
                                if(self.checkDeliveryDateOldValueAndApplyRule(widget)){
                                    
                                    if(self.checkAmountOldValueAndApplyRule(widget)){
                                        
                                        self.applyGRRulesToChangeProductsDeliveryDates(widget).then(function(response){
                                            if(response){
                                                
                                                self.checkDeliveryDateChange(widget).then(function(){
                                                
                                                    self.saveProductEditing(widget);
                                                    
                                                });
                                                
                                            }    
                                            
                                        });
                                    }
                                }
                            }
                        }
                    });
                }
            });
           
        }
        
    };
    
    /**
     * Verifica se o sistema em uso pertence ao cliente "GR", e se o usuário
     * está inserindo uma nova data de entrega no produto de uma uma af, em que
     * já existem solicitações de novas quantidades, garantindo a regra de
     * alteração única por produto.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF").
    */
    this.applyGRRulesToChangeProductsDeliveryDates = function(widget){
        
        var currentRow = widget.currentRow;
        var backupRow = widget.backupRow;
        
        var zhPromise = ZHPromise.defer();
        
        if(this.isGrSystem() && backupRow.DTNOVAENTRAF !== currentRow.DTNOVAENTRAF){
            deleteleftAndRightActions(widget.currentRow);
            
            return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/getProductsWithNewDeliveryDate", "Row", widget.currentRow)
            .then(function(response){
                
                var products = response.dataset.PRODUCTS;
                if(products.length > 0){
                    MessageService.showMessageByCode("OPR_BLOCK_PROD_EXISTENTES");
                    return false;
                    
                } else {
                    return true;
                }
                
            }); 
            
        } else {
            
            zhPromise.resolve(true);
            return zhPromise.promise;
            
        }   
        
    };
    
    function deleteleftAndRightActions(row) {
        delete row.__leftActions;
        delete row.__rightActions;
    }
    
    /**
     * Cria uma cópia do backup da row selecionada
     * na widget recebida como parâmetro.
     * 
     * @param {object} widget widget que recebera a cópia.
    */
    this.createBackupRowCopyOnWidget = function(widget){
        widget.BACKUPROWCOPY = angular.copy(widget.backupRow);
    };
    
    /**
     * Verifica se o usuário deseja replica a data
     * de entrega, inserida no registro em caso, para
     * todos os outros produtos relacionados a AF em caso.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.checkDeliveryDateChange = function(widget){
        
        var zhPromise = ZHPromise.defer();
        var parentWidgetCurrentRow = widget.getParent().currentRow;
        delete widget.currentRow.__rightActions;
        delete widget.currentRow.__leftActions;
        
        if(widget.BACKUPROWCOPY.DTNOVAENTRAF !== widget.currentRow.DTNOVAENTRAF && parentWidgetCurrentRow.IDGERAFDTENT === 'S'){
            
            ScreenService.confirmMessage("Devido ao parâmetro do fornecedor 'Gerar AF por Data de Entrega' as datas de entregas dos demais itens serão alteradas. Deseja continuar?", 'question',
                
                function (success){
                    
                    General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/updateAllAfProductDeliveryDate", "Row", widget.currentRow).then(function(){
                        
                        zhPromise.resolve();
                        
                    });
                    
                }.bind(this),
                function(){
                    zhPromise.reject();
                    const field = templateManager.container.getWidget('WDGT_INSERT_PRODUTOS_AF').getField('DTNOVAENTRAF');
                    field.clearValue(field);
                }
                
            );
            
        } else {
            zhPromise.resolve();
        }
        
        return zhPromise.promise;
        
    };
    
    
    this.checkParamAfForDeliveryDate = function(idgerafdtent, widget, currentRow){
        
        if(idgerafdtent === 'S') {
                    
            var productsData = widget.container.getWidget('WDGT_PRODUTOS_AF').dataSource.data;
            var dtprogitmaf = productsData.length ? productsData[0].DTPROGITMAF : '';
            
            if(dtprogitmaf && dtprogitmaf !== currentRow.DTNOVAENTRAF) {
        
                var message = "Operação bloqueada!<br/><br/>Devido ao parâmetro do fornecedor 'Gerar AF por Data de Entrega' a data de entrega deve ser igual a dos demais produtos.";
                this.cleanNewDateDeliveryFieldAndShowMessage(widget, message);
                
                return false;
                
            } else {
                
                return true;
                
            }
                    
        } else {
            
            return true;
            
        }
        
    };

    
    /**
     * Salva a edição de um produto.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.saveProductEditing = function(widget) {
        if (widget.isValid()) {
            const rowToSave = this.setProductValuesToSaveOnRowToSave(widget);
            
            General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/crud/itemautf_produto_marca/save", "Row", rowToSave).then(function() {
                General.widgetGoBackToList(widget);
                templateManager.container.getWidget('WDGT_PRODUTOS_AF').reload();
                this.checkIfProductEditingWiilBeNotificated(widget);
            }.bind(this));
            
            widget.reload();
        }
    };
    
    /**
     * Função resposável por salvar os novos produtos que estão sendo inseridos
     * na AF. Realiza uma serie de procedimentos que estão relacionados a 
     * inserção do item.
     * 
     * @param {widget} widget widget WDGT_INSERT_PRODUTOS_AF onde são informados
     * os dados do produto que será inserido.
    */
    this.saveNewProductAF = function(widget){
        
        if(widget.isValid()){
            if(this.verifyMaxValue(widget.currentRow.VRPREUNIAF) == false || this.verifyMaxValue(widget.currentRow.QTNOVAPROGAF) == false){
                MessageService.showMessageByCode("OPR_BLOCK_VLR_EXCEDE_MAX");
            }else{
                var mainWidget        = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
                var productWidget     = widget.container.getWidget('WDGT_PRODUTOS_AF');
                var currentRowProduct = widget.currentRow;
                var limitParam        = [];
                var inconsisParam     = [];
                var products          = '';
                
                currentRowProduct.CDFILCENT    = mainWidget.CENTRAL_VENDA;
                currentRowProduct.CDFILDEST    = mainWidget.currentRow.CDFILDEST;
                currentRowProduct.CDFILLANC    = mainWidget.currentRow.CDFILLANC;
                currentRowProduct.NRAUTOFORN   = mainWidget.currentRow.NRAUTOFORN;
                currentRowProduct.CDFORNECED   = mainWidget.currentRow.CDFORNECED;
                currentRowProduct.QTNOVAPROGAF = this.parseStringToFloat(currentRowProduct.QTNOVAPROGAF);
                currentRowProduct.QTPROGENTAF  = 0;
                currentRowProduct.VRPREUNIAF   = this.parseStringToFloat(currentRowProduct.VRPREUNIAF);
                currentRowProduct.DTPROGENTAF  = currentRowProduct.DTNOVAENTRAF;
                currentRowProduct.IDTIPOLANITM = 'M';
                currentRowProduct.NRORG        = getLocalVar('NRORG');
                
                widget.dataSource.data = [];
                
                widget.saveRow().then(function(){
                    const widProdInsert = templateManager.container.getWidget('WDGT_INSERT_PRODUTOS_AF');
                    const fieldDtEntrega = widProdInsert.getField('DTNOVAENTRAF');
                    
                    fieldDtEntrega.clearValue(fieldDtEntrega);
                    productWidget.reload();
                    this.closeSwipe(productWidget);
                    MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
                    
                    this.getInconsistencyAF(currentRowProduct).then(function(inconsistency){
                        
                        inconsistency.dataset.inconsistencia.forEach(function(inconsist){
                            if(inconsist.CDERRO[0] == "L")
                                limitParam.push(inconsist.CDERRO);
                            else if(inconsist.CDERRO[0] == "I")
                                inconsisParam.push(inconsist.CDERRO);
                        });
                        
                        this.updateInconsistencyAF([limitParam, inconsisParam, currentRowProduct]).then(function(){
                            
                        this.insertTaxes(currentRowProduct);
                            
                        }.bind(this));
                        
                    }.bind(this));
                    
                }.bind(this))
                .catch(function(error){
                    ScreenService.showMessage(error.data.error);
                });
            }
            
        }
        
    };
    
    /**
     * Função para removar mascarás de moedas do valor
     * recebido como parâmetro.
     * 
     * @param {String} valueWithCurrencyMask valor que 
     * será retornado sem máscara de moeda.
     * 
     * @return {String} valueWithoutSymbols valor
     * recebido como parâmetro sem máscara de moeda.
     * 
    */
    this.removeValueCurrencyMask = function(valueWithCurrencyMask){
        
        if(valueWithCurrencyMask){
            
            var valuesWithoutCurrencyMask = $.currency.unmaskString(valueWithCurrencyMask, {"thousands": "."});
            return valuesWithoutCurrencyMask;
            
        }else{
            return "";
        }
        
    };
    
    /**
     * Verifica se uma af será notificada sobre alterações realizadas
     * em seus produtos.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.checkIfProductEditingWiilBeNotificated = function(widget) {
        const currentRow = widget.currentRow;
        
        if (currentRow.EDITEDPRODUCT) {
            if (this.isGrSystem()) {
                this.defineAfToSendEmail(widget);
            } else {
                ScreenService.confirmMessage(ScreenService.i18n('Deseja enviar e-mail para o(s) operador(es) responsável pela AF?'), 'question',
                    function (success) {
                        this.defineAfToSendEmail(widget);
                        this.notifiesAfResponsibleAboutProductEditing(widget);
                    }.bind(this)
                );
            }
        }
    };
    
    /**
     * Verifica se o cliente
     * que está logado no sistema
     * é a GR.
    */
    this.isGrSystem = function(){
        
        var paramGeral = this.getGeralParam();
        
        if(parseInt(paramGeral.IDSISDOS, 10) === 3){
            return true;
        } else {
            return false;
        }
    };
    
    /**
     * Define uma af para ser notificada da 
     * modificação do produto.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.defineAfToSendEmail = function(widget) {
        const currentRow = widget.currentRow;
        
        if (!Boolean(widget.CHANGED_AFS) || widget.CHANGED_AFS.NRAUTOFORN !== currentRow.NRAUTOFORN) {
            let afInfos = {
                NRAUTOFORN: currentRow.NRAUTOFORN
            };
            
            afInfos = this.getAfBranchsAndSetOnObject(afInfos);
            
            widget.CHANGED_AFS = afInfos;    
        }
    };
    
    /**
     * Define os valores a serem salvo ,em uma edição de produto, e retorna-os como objeto.
     * 
     * @param {object} widget widget de produtos, onde está ocorrendo
     * a rotina de edição.
     * 
     * @param {object} objeto com as informações a serem salvas.
    */
    this.setProductValuesToSaveOnRowToSave = function(widget){
        
        var currentRow = widget.currentRow;
        var valuesToSave = [
            "__is_new",
            "QTNOVAPROGAF", 
            "DSJUSTITMAF", 
            "DTNOVAENTRAF", 
            "IDTIPOLANITM", 
            "CDOPERADORITMAF",
            "DSJUSTITMAFRPV",
            "CDFILDEST",
            "CDFILLANC",
            "NRAUTOFORN",
            "CDMARCA",
            "CDPRODUTO",
            "DTPROGENTAF"
        ];
        
        var rowToSave = {};
        valuesToSave.forEach(function(value){
            rowToSave[value.valueOf()] = currentRow[value];
        });
        
        rowToSave.QTNOVAPROGAF = this.removeValueCurrencyMask(rowToSave.QTNOVAPROGAF);
        
        return rowToSave;
        
    };
    
    /**
     * Realiza uma chamada no backend para a função que dispera
     * emails para os responsáveis da AF relacionada com o produto
     * em edição.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF").
    */
    this.notifiesAfResponsibleAboutProductEditing = function(widget) {
        const currentRow = widget.currentRow;
        
        if (Boolean(widget.CHANGED_AFS) && Boolean(currentRow.EDITEDPRODUCT)) {
            let row = widget.CHANGED_AFS;
            row.FILIAL_LOGADA = getLocalVar("CDFILIAL");
            row.EMAIL_LOGADO = getLocalVar("EMAIL");
            
            General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/sendEmailToProductResponsibleOperators", "Row", row).then(function(){
                delete widget.CHANGED_AFS;
                delete currentRow.EDITEDPRODUCT;
            }).catch(function(error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };
    
    /**
     * Seta no objeto, recebido como parâmetro, o código e
     * o nome das filiais, de lançamento e de destino, da af em caso.
     * 
     * @param {object} object objeto que será modificada.
     * 
     * @return {object} objeto a ser modificado;
    */
    this.getAfBranchsAndSetOnObject = function(object){
        const mainWidget = templateManager.container.getWidget("WDGT_ALTERACAO_APROVACAO_AF");
        
        object.CDFILLANC = mainWidget.currentRow.CDFILLANC;
        object.NMFILLANC = mainWidget.currentRow.NMFILLANC;
        
        object.CDFILDEST = mainWidget.currentRow.CDFILDEST;
        object.NMFILDEST = mainWidget.currentRow.NMFILDEST;
        
        return object;
    };
    
    /**
     * Controla o estado dos campos para inserção de um novo produto. Verifica
     * se o cliente é a GR ou o parametro IDCARPRECLAF, caso retorne 'S', o 
     * sistema verificará se existe o melhor preço, caso exista, os campos são
     * preenchidos e bloqueados. Caso não exista o melhor preço, o cliente não
     * seja a GR ou o parametro seja 'N', os campos são liberados para 
     * preenchimento do usuário.
     * 
     * @param {object} widget widget WDGT_INSERT_PRODUTOS_AF onde são preenchidos
     * os dados do produto inserido.
    */
    this.checkReadOnlyFieldsAddProduct = function(widget){
        var alteraprovWid = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
        var loadBestPrice = alteraprovWid.PERMISSIONS && alteraprovWid.PERMISSIONS.length ? alteraprovWid.PERMISSIONS[0].IDCARPRECLAF : null;
        
        if(loadBestPrice === 'S' || this.isGrSystem()){
            this.setFieldReadOnlyProperty(widget.getField('VRPREUNIAF'), true);
            this.setFieldReadOnlyProperty(widget.getField('QTNOVAPROGAF'), true);
            this.setFieldReadOnlyProperty(widget.getField('TIPOJUSTI'), true);
            this.setFieldReadOnlyProperty(widget.getField('NMMARCA'), true);
            this.setFieldReadOnlyProperty(widget.getField('DSJUSTITMAF'), true);
            this.setFieldRequireValidation(widget.getField('QTNOVAPROGAF'), false);
            this.setFieldRequireValidation(widget.getField('DSJUSTITMAF'), false);
        } else {
            this.setFieldReadOnlyProperty(widget.getField('VRPREUNIAF'), false);
            this.setFieldReadOnlyProperty(widget.getField('QTNOVAPROGAF'), false);
            this.setFieldReadOnlyProperty(widget.getField('TIPOJUSTI'), false);
            this.setFieldReadOnlyProperty(widget.getField('DSJUSTITMAF'), false);
            this.setFieldRequireValidation(widget.getField('VRPREUNIAF'), true);
            this.setFieldRequireValidation(widget.getField('QTNOVAPROGAF'), true);
            this.setFieldRequireValidation(widget.getField('DSJUSTITMAF'), true);
        }
        
    };
    
    /**
     * Aplica filtro na pesquisa de produto, pegando valores da widget principal
     * e dos parâmetros da AF
     * 
     * @param {object} field field NMPRODUTO que receberá o filtro
    */
    this.applyDataSourceFilterProduct = function(field){
        
        var mainWidget = field.widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
        
        var params = {
            'CDFILDEST': mainWidget.currentRow.CDFILDEST,
            'CDFORNECED': mainWidget.currentRow.CDFORNECED,
            'CDGRUPPROD': mainWidget.PERMISSIONS[0].CDGRUPPROD,
            'CDSUBGRUPPROD': mainWidget.PERMISSIONS[0].CDSUBGRUPPROD,
            'CDPRODUTO': ''
        };
        
        General.onClickDependentField(field, params);
        
    };
    
    /**
     * Função ativada ao alterar o campo produto da tela de inserção de produtos
     * 
     * @param {widget} widget widget WDGT_INSERT_PRODUTOS_AF
    */
    this.productFieldOnChangeAddProduct = function(widget){
        
        this.applyReadOnlyBrand(widget);
        this.checkBestPrice(widget);
        
    };
    
    /**
     * Verifica se o produto foi preenchido para liberar o preenchimento da marca,
     * pois são campos vinculados.
     * 
     * @param {object} widget widget WDGT_INSERT_PRODUTOS_AF
    */
    this.applyReadOnlyBrand = function(widget){
        
        var fieldBrand = widget.getField('NMMARCA');
        var fieldProduct = widget.getField('NMPRODUTO');
        var loadBestPrice = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF').PERMISSIONS[0].IDCARPRECLAF;
        
        fieldBrand.setValue('');
        
        if(fieldProduct.value() && (loadBestPrice === 'N' || !this.isGrSystem())){
            this.setFieldReadOnlyProperty(fieldBrand, false);
            this.setFieldRequireValidation(fieldBrand, true);
        } else {
            this.setFieldReadOnlyProperty(fieldBrand, true);
            this.setFieldRequireValidation(fieldBrand, false);
        }
        
    };
    
    /**
     * 
     * Caso o sistema reconheça que o usuário logado
     * pertença ao cliente GR ou que o parametro IDCARPRECLAF seja igual 'S',
     * o mesmo irá verificar se a nova data e produto foram preenchidos e buscar
     * o melhor preço.
     * 
     * 
    */ 
    this.checkBestPrice = function(widget){
        
        var currentRow = widget.currentRow;
        var mainWidget = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
        var loadBestPrice = mainWidget.PERMISSIONS[0].IDCARPRECLAF;
        
        if(loadBestPrice === 'S' || this.isGrSystem()){
            
            if(currentRow.CDPRODUTO && currentRow.DTNOVAENTRAF){
                
                var params = [
                    { 'name': 'CDPRODUTO',      'operator': '=',    'value': currentRow.CDPRODUTO },
                    { 'name': 'CDCENTCMP',      'operator': '=',    'value': mainWidget.CENTRAL_VENDA },
                    { 'name': 'CDFORNECED',     'operator': '=',    'value': mainWidget.currentRow.CDFORNECED },
                    { 'name': 'CDFILDEST',      'operator': '=',    'value': mainWidget.currentRow.CDFILDEST },
                    { 'name': 'DTPROGENTAF',    'operator': '=',    'value': currentRow.DTNOVAENTRAF }
                ];
                
                General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/crud/retornaMelhorPreco', "FilterData", params).then(function(response){
                    var retornaMelhorPreco = response.dataset.retornaMelhorPreco;
                    
                    if(retornaMelhorPreco.length){
                        currentRow.VRPREUNIAF = retornaMelhorPreco[0].VRPRECUNIITM;
                        currentRow.CDMARCA = retornaMelhorPreco[0].CDMARCA;
                        currentRow.NMMARCA = retornaMelhorPreco[0].NMMARCA;
                        
                        this.setFieldReadOnlyProperty(widget.getField('TIPOJUSTI'), false);
                        this.setFieldReadOnlyProperty(widget.getField('DSJUSTITMAF'), false);
                        this.setFieldReadOnlyProperty(widget.getField('QTNOVAPROGAF'), false);
                        this.setFieldReadOnlyProperty(widget.getField('NMMARCA'), true);
                        this.setFieldReadOnlyProperty(widget.getField('VRPREUNIAF'), true);
                        this.setFieldRequireValidation(widget.getField('QTNOVAPROGAF'), true);
                        this.setFieldRequireValidation(widget.getField('DSJUSTITMAF'), true);
                        this.setFieldRequireValidation(widget.getField('NMMARCA'), false);
                        this.setFieldRequireValidation(widget.getField('VRPREUNIAF'), false);
                    } else {
                        this.setFieldReadOnlyProperty(widget.getField('QTNOVAPROGAF'), false);
                        this.setFieldReadOnlyProperty(widget.getField('TIPOJUSTI'), false);
                        this.setFieldReadOnlyProperty(widget.getField('DSJUSTITMAF'), false);
                        this.setFieldReadOnlyProperty(widget.getField('NMMARCA'), false);
                        this.setFieldReadOnlyProperty(widget.getField('VRPREUNIAF'), false);
                        this.setFieldRequireValidation(widget.getField('NMMARCA'), true);
                        this.setFieldRequireValidation(widget.getField('VRPREUNIAF'), true);
                        this.setFieldRequireValidation(widget.getField('QTNOVAPROGAF'), true);
                        this.setFieldRequireValidation(widget.getField('DSJUSTITMAF'), true);
                    }
                    
                    currentRow.TIPOJUSTI = 'S';
                    widget.redraw();
                }.bind(this))
                .catch(function(error){
                    ScreenService.showMessage(error.data.error);
                });
                
            }
            
        }
    };
    
    /**
     * Retorna as insconsistencias da AF.
     * 
     * @param {params} Array Array com os parametros necessários
    */
    this.getInconsistencyAF = function(params) {
     
        params = [
            { 'name': 'NRAUTOFORN',     'operator': '=',    'value': params.NRAUTOFORN },
            { 'name': 'CDFILCENT',      'operator': '=',    'value': params.CDFILCENT },
            { 'name': 'CDFILDEST',      'operator': '=',    'value': params.CDFILDEST },
            { 'name': 'CDFILLANC',      'operator': '=',    'value': params.CDFILLANC },
            { 'name': 'CDPRODUTO',      'operator': '=',    'value': '' },
            { 'name': 'CDMARCA',        'operator': '=',    'value': '' },
            { 'name': 'DTPROGENTAF',    'operator': '=',    'value': '' }
        ];
        
        return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/crud/inconsistencia", "FilterData", params);
        
    };
    
    /**
     * Atualiza a AF como inconsistente caso alguma inconsistencia seja 
     * encontrada
     * 
     * @param {params} Array Array com os parametros necessários
    */
    this.updateInconsistencyAF = function(params){
        return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/updateInconsistencyAF", "Row", params);
    };
    
    /**
     * Insere os impostos para a empresa relacionada a AF
     * 
     * @param {params} Array Array com os parametros necessários
    */
    this.insertTaxes = function(params){
        return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/insertTaxes", "Row", params);
    };
    
    /**
     * Fecha o swipe e ativa a widget passada como parametro.
     * 
     * @param {widget} widget widget que será ativada após o swipe ser fechado
    */
    this.closeSwipe = function(widget){
        const widProdInsert = templateManager.container.getWidget('WDGT_INSERT_PRODUTOS_AF');
        const fieldDtEntrega = widProdInsert.getField('DTNOVAENTRAF');
        
        fieldDtEntrega.clearValue(fieldDtEntrega);
        ScreenService.closeSwipe();
        widget.activate();
    };
    
    /**
     * Função criada para contornar um erro no master detail do Zeedhi, que 
     * mesmo ativando a widget, as actions da widget anterior permanecem.
     * 
     * @param {widget} widget widget ativa no momento da chamada da função.
    */
    this.controlActionsProduct = function(widget){
        
        var isVisible = false;
        //const widAlteracaoRow = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF').currentRow;
        
        if(widget.name === 'WDGT_ALTERACAO_APROVACAO_AF'){
            
            widget = widget.container.getWidget('WDGT_PRODUTOS_AF');
            isVisible = true;
            
        }
        
        var actionIncluir = widget.getAction('INCLUIR_PRODUTO');
        var actionVoltar = widget.getAction('VOLTAR_LISTA');
        //var actionSituacao = widget.getAction('situacao');
        
        /*if(widAlteracaoRow.IDAFFORALIM == 'S' || widAlteracaoRow.IDSITUATUAAF){
            actionSituacao.isVisible = true;
            delete actionSituacao.condition;
        }else{
            actionSituacao.isVisible = false;
            actionSituacao.condition = 'row.DSINCONSITAF';
        }*/
        
        actionIncluir.isVisible = isVisible;
        actionVoltar.isVisible = isVisible;
    };
    
    self.validaProduto = function(prodInicial, prodFinal) {
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }

        return true;
    }; 
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp07600_Alteracao_Aprovacao_Af_Controller', Cmp07600_Alteracao_Aprovacao_Af_Controller);
});